"Main interface for cur service Client"
from __future__ import annotations

import sys
from typing import Any, Dict, overload
from botocore.client import BaseClient
from botocore.exceptions import ClientError as Boto3ClientError

# pylint: disable=import-self
import mypy_boto3_cur.client as client_scope

# pylint: disable=import-self
import mypy_boto3_cur.paginator as paginator_scope
from mypy_boto3_cur.type_defs import (
    ClientDeleteReportDefinitionResponseTypeDef,
    ClientDescribeReportDefinitionsResponseTypeDef,
    ClientModifyReportDefinitionReportDefinitionTypeDef,
    ClientPutReportDefinitionReportDefinitionTypeDef,
)

if sys.version_info >= (3, 8):
    from typing import Literal
else:
    from typing_extensions import Literal


__all__ = ("Client",)


class Client(BaseClient):
    """
    [CostandUsageReportService.Client documentation](https://boto3.amazonaws.com/v1/documentation/api/1.10.33/reference/services/cur.html#CostandUsageReportService.Client)
    """

    exceptions: client_scope.Exceptions

    # pylint: disable=arguments-differ,redefined-outer-name,redefined-builtin
    def can_paginate(self, operation_name: str) -> bool:
        """
        [Client.can_paginate documentation](https://boto3.amazonaws.com/v1/documentation/api/1.10.33/reference/services/cur.html#CostandUsageReportService.Client.can_paginate)
        """

    # pylint: disable=arguments-differ,redefined-outer-name,redefined-builtin
    def delete_report_definition(
        self, ReportName: str = None
    ) -> ClientDeleteReportDefinitionResponseTypeDef:
        """
        [Client.delete_report_definition documentation](https://boto3.amazonaws.com/v1/documentation/api/1.10.33/reference/services/cur.html#CostandUsageReportService.Client.delete_report_definition)
        """

    # pylint: disable=arguments-differ,redefined-outer-name,redefined-builtin
    def describe_report_definitions(
        self, MaxResults: int = None, NextToken: str = None
    ) -> ClientDescribeReportDefinitionsResponseTypeDef:
        """
        [Client.describe_report_definitions documentation](https://boto3.amazonaws.com/v1/documentation/api/1.10.33/reference/services/cur.html#CostandUsageReportService.Client.describe_report_definitions)
        """

    # pylint: disable=arguments-differ,redefined-outer-name,redefined-builtin
    def generate_presigned_url(
        self,
        ClientMethod: str,
        Params: Dict[str, Any] = None,
        ExpiresIn: int = 3600,
        HttpMethod: str = None,
    ) -> None:
        """
        [Client.generate_presigned_url documentation](https://boto3.amazonaws.com/v1/documentation/api/1.10.33/reference/services/cur.html#CostandUsageReportService.Client.generate_presigned_url)
        """

    # pylint: disable=arguments-differ,redefined-outer-name,redefined-builtin
    def modify_report_definition(
        self, ReportName: str, ReportDefinition: ClientModifyReportDefinitionReportDefinitionTypeDef
    ) -> Dict[str, Any]:
        """
        [Client.modify_report_definition documentation](https://boto3.amazonaws.com/v1/documentation/api/1.10.33/reference/services/cur.html#CostandUsageReportService.Client.modify_report_definition)
        """

    # pylint: disable=arguments-differ,redefined-outer-name,redefined-builtin
    def put_report_definition(
        self, ReportDefinition: ClientPutReportDefinitionReportDefinitionTypeDef
    ) -> Dict[str, Any]:
        """
        [Client.put_report_definition documentation](https://boto3.amazonaws.com/v1/documentation/api/1.10.33/reference/services/cur.html#CostandUsageReportService.Client.put_report_definition)
        """

    @overload
    # pylint: disable=arguments-differ,redefined-outer-name,redefined-builtin
    def get_paginator(
        self, operation_name: Literal["describe_report_definitions"]
    ) -> paginator_scope.DescribeReportDefinitionsPaginator:
        """
        [Paginator.DescribeReportDefinitions documentation](https://boto3.amazonaws.com/v1/documentation/api/1.10.33/reference/services/cur.html#CostandUsageReportService.Paginator.DescribeReportDefinitions)
        """


class Exceptions:
    ClientError: Boto3ClientError
    DuplicateReportNameException: Boto3ClientError
    InternalErrorException: Boto3ClientError
    ReportLimitReachedException: Boto3ClientError
    ValidationException: Boto3ClientError
